Index: menuitems.cpp
===================================================================
--- menuitems.cpp	(revision 3446)
+++ menuitems.cpp	(working copy)
@@ -442,10 +442,10 @@
 {
 	if (image_ != NULL)
 	{
-		image = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, image_->w, image_->h, Video.getColDepth(), 0, 0, 0, 0);
+		image = SDL_CreateRGBSurface (0, image_->w, image_->h, Video.getColDepth(), 0, 0, 0, 0);
 
 		SDL_FillRect (image, NULL, 0xFF00FF);
-		SDL_SetColorKey (image, SDL_SRCCOLORKEY, 0xFF00FF);
+		SDL_SetColorKey (image, SDL_TRUE, 0xFF00FF);
 
 		SDL_BlitSurface (image_, NULL, image, NULL);
 
@@ -702,8 +702,8 @@
 			src.y = isClicked ? 0 : 132;
 			break;
 	}
-	surface = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0xFF00FF);
+	surface = SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_SetColorKey (surface, SDL_TRUE, 0xFF00FF);
 	SDL_FillRect (surface, NULL, 0xFF00FF);
 	if (buttonType >= BUTTON_TYPE_HUD_HELP && buttonType <= BUTTON_TYPE_HUD_STOP) SDL_BlitSurface (GraphicsData.gfx_hud_stuff, &src, surface, NULL);
 	else SDL_BlitSurface (GraphicsData.gfx_menu_stuff, &src, surface, NULL);
@@ -716,7 +716,6 @@
 	renewButtonSurface();
 	draw();
 	Video.draw();
-	mouse->draw (false, screen);
 }
 
 int cMenuButton::getTextYOffset() const
@@ -899,7 +898,6 @@
 	}
 
 	Video.draw();
-	mouse->draw (false, screen);
 }
 
 void cMenuDestroyButton::animationCallback()
@@ -1048,7 +1046,7 @@
 	}
 	if (src.w > 0)
 	{
-		surface = SDL_CreateRGBSurface (Video.getSurfaceType(), src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
+		surface = SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
 		if (buttonType >= CHECKBOX_HUD_INDEX_00 && buttonType <= CHECKBOX_HUD_PLAYERS) SDL_BlitSurface (GraphicsData.gfx_hud_stuff, &src, surface, NULL);
 		else SDL_BlitSurface (GraphicsData.gfx_menu_stuff, &src, surface, NULL);
 	}
@@ -1070,7 +1068,6 @@
 	}
 	draw();
 	Video.draw();
-	mouse->draw (false, screen);
 	return true;
 }
 
@@ -1112,7 +1109,7 @@
 			font->showText (position.x, position.y, text, fontType);
 			if (checked)
 			{
-				const Uint32 selection_color (0x00E3DACF);
+				const Uint32 selection_color (0xFFE3DACF);
 				const SDL_Rect dest = {Sint16 (position.x - 2), Sint16 (position.y - 1), Uint16 (position.w + 5), Uint16 (position.h + 2) };
 				DrawRectangle (buffer, dest, selection_color);
 			}
@@ -1209,7 +1206,7 @@
 
 void cMenuRadioGroup::clicked (void* parent)
 {
-	mouse->GetPos();
+	mouse->updatePos();
 	for (unsigned int i = 0; i < buttonList.size(); i++)
 	{
 		if (buttonList[i]->overItem (mouse->x, mouse->y))
@@ -1252,8 +1249,8 @@
 void cMenuUnitListItem::init()
 {
 	const int UNIT_IMAGE_SIZE = 32;
-	surface = SDL_CreateRGBSurface (SDL_SRCCOLORKEY, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0x00FF00FF);
+	surface = SDL_CreateRGBSurface (0, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_SetColorKey (surface, SDL_TRUE, 0x00FF00FF);
 	SDL_FillRect (surface, NULL, 0x00FF00FF);
 	SDL_Rect dest = {0, 0, 0, 0};
 
@@ -1288,7 +1285,7 @@
 	if (selected)
 	{
 		const SDL_Rect dest = { Sint16 (position.x - 4), Sint16 (position.y - 4), 38, 38};
-		DrawSelectionCorner (buffer, dest, 8, 0x00E0E0E0);
+		DrawSelectionCorner (buffer, dest, 8, 0xFFE0E0E0);
 	}
 
 	switch (displayType)
@@ -1484,7 +1481,7 @@
 
 void cMenuUnitsList::released (void* parent)
 {
-	mouse->GetPos();
+	mouse->updatePos();
 	for (int i = offset; i < offset + maxDisplayUnits; i++)
 	{
 		if (i >= (int) unitsList.size()) break;
@@ -1674,7 +1671,7 @@
 	dest.x += src.w + 3;
 	SDL_Rect mark = { Sint16 (dest.x - src.w / 2), dest.y, 1, src.h };
 
-	SDL_FillRect (buffer, &mark, 0xFC0000);
+	SDL_FillRect (buffer, &mark, 0xFFFC0000);
 
 	if (symType == MENU_SYMBOLS_METAL)
 	{
@@ -1905,11 +1902,11 @@
 	if (drawLines)
 	{
 		SDL_Rect lineRect = { Sint16 (position.x + 2), Sint16 (position.y + 14), 153, 1 };
-		SDL_FillRect (buffer, &lineRect, 0x743904);
+		SDL_FillRect (buffer, &lineRect, 0xFF743904);
 		lineRect.y += 12;
-		SDL_FillRect (buffer, &lineRect, 0x743904);
+		SDL_FillRect (buffer, &lineRect, 0xFF743904);
 		lineRect.y += 12;
-		SDL_FillRect (buffer, &lineRect, 0x743904);
+		SDL_FillRect (buffer, &lineRect, 0xFF743904);
 	}
 	if (unit == NULL) return;
 	const sUnitData* data = &unit->data;
@@ -2127,7 +2124,7 @@
 	const int DETAIL_COLUMN_1 = dest.x + 27;
 	const int DETAIL_COLUMN_2 = dest.x + 42;
 	const int DETAIL_COLUMN_3 = dest.x + 95;
-#define DETAIL_DOLINEBREAK dest.y = y + 14; SDL_FillRect (buffer, &dest, 0xFC0000); y += 19;
+#define DETAIL_DOLINEBREAK dest.y = y + 14; SDL_FillRect (buffer, &dest, 0xFFFC0000); y += 19;
 
 	if (data->canAttack)
 	{
@@ -2349,8 +2346,8 @@
 void cMenuMaterialBar::generateSurface()
 {
 	SDL_Rect src = { 114, 336, position.w, position.h };
-	surface = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0xFF00FF);
+	surface = SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_SetColorKey (surface, SDL_TRUE, 0xFF00FF);
 	SDL_FillRect (surface, NULL, 0xFF00FF);
 
 	switch (materialType)
@@ -2568,11 +2565,11 @@
 	position.h = src.h;
 	mouseXOff = mouseYOff = 0;
 
-	surface = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, position.w, position.h, Video.getColDepth(), 0, 0, 0, 0);
+	surface = SDL_CreateRGBSurface (0, position.w, position.h, Video.getColDepth(), 0, 0, 0, 0);
 	SDL_FillRect (surface, NULL, 0xFF00FF);
 	if (scrollerType == SCROLLER_TYPE_HUD_ZOOM) SDL_BlitSurface (GraphicsData.gfx_hud_stuff, &src, surface, NULL);
 	else SDL_BlitSurface (GraphicsData.gfx_menu_stuff, &src, surface, NULL);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0xFF00FF);
+	SDL_SetColorKey (surface, SDL_TRUE, 0xFF00FF);
 }
 
 void cMenuScroller::draw()
@@ -2663,7 +2660,7 @@
 {
 	SDL_Rect src = { 234, 1, 16, 48};
 	SDL_Rect dest = { 0, 0, 0, 0 };
-	surface = SDL_CreateRGBSurface (Video.getSurfaceType(), 16, position.h - 28, Video.getColDepth(), 0, 0, 0, 0);
+	surface = SDL_CreateRGBSurface (0, 16, position.h - 28, Video.getColDepth(), 0, 0, 0, 0);
 	do
 	{
 		if (position.h - 28 - dest.y < 48) src.h = position.h - 28 - dest.x;
@@ -2961,7 +2958,7 @@
 	}
 }
 
-bool cMenuLineEdit::handleKeyInput (SDL_keysym keysym, const string& ch, void* parent)
+bool cMenuLineEdit::handleKeyInput (const SDL_Keysym& keysym, cMenu* parent)
 {
 	if (readOnly) return false;
 
@@ -2995,28 +2992,7 @@
 			if (wasKeyInput) wasKeyInput (parent);
 			break;
 		default: // no special key - handle as normal character:
-			if (keysym.unicode >= 32)
-			{
-				if (keysym.unicode >= 48 && keysym.unicode <= 57)
-				{
-					if (!takeNumerics) break;
-				}
-				else if (!takeChars) break;
-
-				text.insert (cursorPos, ch);
-				if (cursorPos < (int) text.length()) doPosIncrease (cursorPos, cursorPos);
-				if (cursorPos >= endOffset)
-				{
-					doPosIncrease (endOffset, endOffset);
-					while (font->getTextWide (text.substr (startOffset, endOffset - startOffset), fontType) > position.w - getBorderSize()) doPosIncrease (startOffset, startOffset);
-				}
-				else
-				{
-					if (font->getTextWide (text.substr (startOffset, endOffset - startOffset), fontType) > position.w - getBorderSize()) doPosDecrease (endOffset);
-					else doPosIncrease (endOffset, cursorPos);
-				}
-				if (wasKeyInput) wasKeyInput (parent);
-			}
+			addText (keysym, parent);
 			break;
 	}
 	parentMenu->draw();
@@ -3023,6 +2999,34 @@
 	return true;
 }
 
+void cMenuLineEdit::addText (const SDL_Keysym& keysym, cMenu* parent)
+{
+	if (keysym.sym >= 32)
+	{
+		if (keysym.sym >= 48 && keysym.sym <= 57)
+		{
+			if (!takeNumerics) return;
+		}
+		else if (!takeChars) return;
+
+		std::string ch = cInput::getUTF16Char (keysym.sym);
+
+		text.insert (cursorPos, ch);
+		if (cursorPos < (int) text.length()) doPosIncrease (cursorPos, cursorPos);
+		if (cursorPos >= endOffset)
+		{
+			doPosIncrease (endOffset, endOffset);
+			while (font->getTextWide (text.substr (startOffset, endOffset - startOffset), fontType) > position.w - getBorderSize()) doPosIncrease (startOffset, startOffset);
+		}
+		else
+		{
+			if (font->getTextWide (text.substr (startOffset, endOffset - startOffset), fontType) > position.w - getBorderSize()) doPosDecrease (endOffset);
+			else doPosIncrease (endOffset, cursorPos);
+		}
+		if (wasKeyInput) wasKeyInput (parent);
+	}
+}
+
 void cMenuLineEdit::setReturnPressedFunc (void (*returnPressed_) (void*))
 {
 	returnPressed = returnPressed_;
@@ -3038,9 +3042,9 @@
 {
 	if (Video.getResolutionX() - HUD_TOTAL_WIDTH - 20 < 60) return;
 
-	surface = SDL_CreateRGBSurface (Video.getSurfaceType(), Video.getResolutionX() - HUD_TOTAL_WIDTH - 20, 48, Video.getColDepth(), 0, 0, 0, 0);
+	surface = SDL_CreateRGBSurface (0, Video.getResolutionX() - HUD_TOTAL_WIDTH - 20, 48, Video.getColDepth(), 0, 0, 0, 0);
 	SDL_FillRect (surface, NULL, 0xFF00FF);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0xFF00FF);
+	SDL_SetColorKey (surface, SDL_TRUE, 0xFF00FF);
 
 	SDL_Rect src = { 0, 0, 30, 48 };
 	SDL_Rect dest = { 0, 0, 0, 0 };
@@ -3118,14 +3122,14 @@
 {
 	SDL_Rect src = { 10, 0, 10, 10 };
 
-	AutoSurface readySurface (SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
-	SDL_SetColorKey (readySurface, SDL_SRCCOLORKEY, 0xFF00FF);
+	AutoSurface readySurface (SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
+	SDL_SetColorKey (readySurface, SDL_TRUE, 0xFF00FF);
 	SDL_FillRect (readySurface, NULL, 0xFF00FF);
 	SDL_BlitSurface (GraphicsData.gfx_player_ready, &src, readySurface, NULL);
 
 	src.x -= 10;
-	AutoSurface notReadySurface (SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
-	SDL_SetColorKey (notReadySurface, SDL_SRCCOLORKEY, 0xFF00FF);
+	AutoSurface notReadySurface (SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
+	SDL_SetColorKey (notReadySurface, SDL_TRUE, 0xFF00FF);
 	SDL_FillRect (notReadySurface, NULL, 0xFF00FF);
 	SDL_BlitSurface (GraphicsData.gfx_player_ready, &src, notReadySurface, NULL);
 
@@ -3137,7 +3141,7 @@
 			if ( (*players) [i]->isReady()) playerReadys[index]->setImage (readySurface);
 			else playerReadys[index]->setImage (notReadySurface);
 
-			AutoSurface colorSurface (SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
+			AutoSurface colorSurface (SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
 			SDL_BlitSurface ( (*players) [i]->getColorSurface(), &src, colorSurface, NULL);
 			playerColors[index]->setImage (colorSurface);
 
@@ -3420,7 +3424,7 @@
 			position.w = src.w;
 			position.h = src.h;
 
-			surface = SDL_CreateRGBSurface (Video.getSurfaceType(), src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
+			surface = SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0);
 			SDL_BlitSurface (GraphicsData.gfx_menu_stuff, &src, surface, NULL);
 
 			scroller = new cMenuScroller (x - 7, y - 7, cMenuScroller::SCROLLER_TYPE_HORI, this, &scrollerMoved);
@@ -3612,7 +3616,7 @@
 	{
 		const int selIndex = selected - index * maxItems;
 		const SDL_Rect rect = {Sint16 (position.x + 13), Sint16 (position.y + 26 + 55 * selIndex), 38, 38};
-		DrawSelectionCorner (buffer, rect, 8, 0x00E0E0E0);
+		DrawSelectionCorner (buffer, rect, 8, 0xFFE0E0E0);
 	}
 }
 
@@ -3941,7 +3945,7 @@
 		{
 			int selIndex = selected - index * maxItems;
 			const SDL_Rect rect = {Sint16 (position.x + 15), Sint16 (position.y + 23 + 55 * selIndex), 450, 53 };
-			DrawRectangle (buffer, rect, 0x00E0E0E0);
+			DrawRectangle (buffer, rect, 0xFFE0E0E0);
 		}
 	}
 }
@@ -4112,8 +4116,8 @@
 	float zoomFactor = (float) UNIT_IMAGE_SIZE / (unit->data.isBig ? 128.0f : 64.0f);
 	SDL_Rect dest = { 0, 0, 0, 0};
 
-	SDL_Surface* surface = SDL_CreateRGBSurface (SDL_SRCCOLORKEY, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0xFF00FF);
+	SDL_Surface* surface = SDL_CreateRGBSurface (0, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_SetColorKey (surface, SDL_TRUE, 0xFF00FF);
 	//SDL_FillRect (surface, NULL, 0xFF00FF);
 
 	if (unit->isABuilding())
Index: menuitems.h
===================================================================
--- menuitems.h	(revision 3446)
+++ menuitems.h	(working copy)
@@ -212,7 +212,7 @@
 	 *@param ch the encoded key
 	 *@param parent pointer to the calling menu
 	 */
-	virtual bool handleKeyInput (SDL_keysym keysym, const std::string& ch, void* parent) { return false; }
+	virtual bool handleKeyInput (const SDL_Keysym& keysym, cMenu* parent) { return false; }
 
 
 	/**
@@ -1028,6 +1028,7 @@
 	bool readOnly;
 	bool takeChars, takeNumerics;
 
+	void addText (const SDL_Keysym& keysym, cMenu* parent);
 	void resetTextPosition();
 	void doPosIncrease (int& value, int pos);
 	void doPosDecrease (int& pos);
@@ -1055,7 +1056,7 @@
 	void setText (const std::string& text_);
 	const std::string& getText() const;
 	void setSize (int w, int h);
-	virtual bool handleKeyInput (SDL_keysym keysym, const std::string& ch, void* parent);
+	virtual bool handleKeyInput (const SDL_Keysym& keysym, cMenu* parent);
 
 	void setReturnPressedFunc (void (*returnPressed_) (void*));
 };
Index: menus.cpp
===================================================================
--- menus.cpp	(revision 3450)
+++ menus.cpp	(working copy)
@@ -234,7 +234,6 @@
 	end = false;
 	terminate = false;
 	activeItem = NULL;
-	drawnEveryFrame = false;
 
 	lastScreenResX = Video.getResolutionX();
 	lastScreenResY = Video.getResolutionY();
@@ -292,10 +291,13 @@
 		case MNU_BG_BLACK:
 			// fill the whole screen with black to prevent
 			// old garbage from menus that don't support resolutions > 640x480
-			SDL_FillRect (buffer, NULL, 0x000000);
+			SDL_FillRect (buffer, NULL, 0xFF000000);
 			break;
 		case MNU_BG_ALPHA:
-			if (cSettings::getInstance().isAlphaEffects() && firstDraw) SDL_BlitSurface (GraphicsData.gfx_shadow, NULL, buffer, NULL);
+			if (cSettings::getInstance().isAlphaEffects() && firstDraw)
+				SDL_BlitSurface (GraphicsData.gfx_shadow, NULL, buffer, NULL);
+			else
+				SDL_FillRect (buffer, NULL, SDL_MapRGBA (buffer->format, 0, 0, 0, 0));
 			break;
 		case MNU_BG_TRANSPARENT:
 			// do nothing here
@@ -318,9 +320,7 @@
 
 	if (showScreen)
 	{
-		if (drawnEveryFrame) mouse->draw (true, buffer);
 		Video.draw();
-		if (!drawnEveryFrame) mouse->draw (false, screen);
 	}
 }
 
@@ -327,8 +327,6 @@
 //------------------------------------------------------------------------------
 int cMenu::show (cClient* client)
 {
-	drawnEveryFrame = false;
-
 	mouse->SetCursor (CHand);
 	draw (true);
 
@@ -357,11 +355,9 @@
 			lastResY = Video.getResolutionY();
 		}
 
-		mouse->GetPos();
+		mouse->updatePos();
 		if (mouse->moved())
 		{
-			mouse->draw (true, screen);
-
 			for (unsigned int i = 0; i < menuItems.size(); i++)
 			{
 				cMenuItem* menuItem = menuItems[i];
@@ -406,7 +402,7 @@
 //------------------------------------------------------------------------------
 void cMenu::handleMouseInput (sMouseState mouseState)
 {
-	mouse->GetPos();
+	mouse->updatePos();
 	mouse->isDoubleClick = mouseState.isDoubleClick;
 
 	for (size_t i = 0; i != menuItems.size(); ++i)
@@ -434,9 +430,9 @@
 }
 
 //------------------------------------------------------------------------------
-void cMenu::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cMenu::handleKeyInput (const SDL_KeyboardEvent& key)
 {
-	if (activeItem && key.state == SDL_PRESSED) activeItem->handleKeyInput (key.keysym, ch, this);
+	if (activeItem && key.state == SDL_PRESSED) activeItem->handleKeyInput (key.keysym, this);
 }
 
 //------------------------------------------------------------------------------
@@ -539,7 +535,6 @@
 	menu->infoImage->setImage (surface);
 	menu->infoImage->draw();
 	Video.draw();
-	mouse->draw (false, screen);
 }
 
 //------------------------------------------------------------------------------
@@ -1312,7 +1307,7 @@
 			const int MAPWINSIZE = 112;
 			const int SELECTED = 0x00C000;
 			const int UNSELECTED = 0x000000;
-			AutoSurface imageSurface (SDL_CreateRGBSurface (Video.getSurfaceType(), MAPWINSIZE + 8, MAPWINSIZE + 8, Video.getColDepth(), 0, 0, 0, 0));
+			AutoSurface imageSurface (SDL_CreateRGBSurface (0, MAPWINSIZE + 8, MAPWINSIZE + 8, Video.getColDepth(), 0, 0, 0, 0));
 
 			if (selectedMapIndex == i + offset)
 			{
@@ -1461,7 +1456,7 @@
 			yCount = 1;
 		}
 		SDL_Surface* img = LoadPCX (clanLogoPaths[i].c_str());
-		SDL_SetColorKey (img, SDL_SRCCOLORKEY, 0xFF00FF);
+		SDL_SetColorKey (img, SDL_TRUE, 0xFF00FF);
 		clanImages[i] = new cMenuImage (position.x + 88 + xCount * 154 - (img ? (img->w / 2) : 0), position.y + 48 + yCount * 150, img);
 		clanImages[i]->setReleasedFunction (&clanSelected);
 		menuItems.push_back (clanImages[i]);
@@ -2215,9 +2210,9 @@
 	menu->landData.landingState = LANDING_POSITION_OK;
 	menu->backButton->setLocked (true);
 	{
-		AutoSurface circleSurface (SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, Video.getResolutionX() - 192, Video.getResolutionY() - 32, Video.getColDepth(), 0, 0, 0, 0));
+		AutoSurface circleSurface (SDL_CreateRGBSurface (0, Video.getResolutionX() - 192, Video.getResolutionY() - 32, Video.getColDepth(), 0, 0, 0, 0));
 		SDL_FillRect (circleSurface, NULL, 0xFF00FF);
-		SDL_SetColorKey (circleSurface, SDL_SRCCOLORKEY, 0xFF00FF);
+		SDL_SetColorKey (circleSurface, SDL_TRUE, 0xFF00FF);
 
 		int posX = (int) (menu->landData.iLandX * fakx);
 		int posY = (int) (menu->landData.iLandY * faky);
@@ -2231,7 +2226,6 @@
 
 	Video.draw();
 	mouse->SetCursor (CHand);
-	mouse->draw (false, screen);
 
 	menu->hitPosition();
 }
@@ -2251,7 +2245,7 @@
 }
 
 //------------------------------------------------------------------------------
-void cLandingMenu::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cLandingMenu::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	if (key.keysym.sym == SDLK_ESCAPE && key.state == SDL_PRESSED)
 	{
@@ -2610,7 +2604,7 @@
 void cNetworkMenu::setColor (int color)
 {
 	SDL_Rect src = { 0, 0, 83, 10 };
-	AutoSurface colorSurface (SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
+	AutoSurface colorSurface (SDL_CreateRGBSurface (0, src.w, src.h, Video.getColDepth(), 0, 0, 0, 0));
 	SDL_BlitSurface (OtherData.colors[color], &src, colorSurface, NULL);
 	colorImage->setImage (colorSurface);
 }
@@ -4608,7 +4602,7 @@
 				upgradeButtons[pos]->setLocked (true);
 			}
 
-			SDL_Surface* surface = SDL_CreateRGBSurface (Video.getSurfaceType(), srcSurface->w, srcSurface->h, Video.getColDepth(), 0, 0, 0, 0);
+			SDL_Surface* surface = SDL_CreateRGBSurface (0, srcSurface->w, srcSurface->h, Video.getColDepth(), 0, 0, 0, 0);
 			SDL_BlitSurface (srcSurface, NULL, surface, NULL);
 			unitImages[pos]->setImage (surface);
 
Index: menus.h
===================================================================
--- menus.h	(revision 3446)
+++ menus.h	(working copy)
@@ -192,7 +192,6 @@
 class cMenu
 {
 protected:
-	bool drawnEveryFrame;
 	/** When this is true the show-loop will be end and give 0 as return.
 	 * Should be used when the menu is closed by ok or done.
 	 */
@@ -276,7 +275,7 @@
 	 * delegates the keyinput to the active menuitem.
 	 *@author alzi
 	 */
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 
 	/**
 	 * sends a netmessage to the given player.
@@ -657,7 +656,7 @@
 	cLandingMenu (cClient& client_, cStaticMap& map_);
 
 private:
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 	virtual void handleNetMessages();
 
 	void handleNetMessage (cNetMessage* message);
Index: mouse.cpp
===================================================================
--- mouse.cpp	(revision 3442)
+++ mouse.cpp	(working copy)
@@ -16,68 +16,33 @@
  *   Free Software Foundation, Inc.,                                       *
  *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
  ***************************************************************************/
+
 #include "mouse.h"
+
 #include "main.h"
 #include "client.h"
 #include "settings.h"
 #include "hud.h"
 
+#include <SDL.h>
 
-cMouse::cMouse()
+cMouse::cMouse() : sdlCursor (NULL)
 {
-	visible = false;
 	cur = NULL;
-	LastX = -100;
-	LastY = -100;
 	x = 0;
 	y = 0;
 	isDoubleClick = false;
-	prevScreenX = 0;
-	prevScreenY = 0;
-
-	DrawX = 0;
-	DrawY = 0;
 }
 
-// Malt die Maus, und wenn draw_back gesetzt ist, auch den alten Hintergrund:
-void cMouse::draw (bool draw_back, SDL_Surface* sf)
+cMouse::~cMouse()
 {
-	if (!visible || cur == NULL) return;
-	GetPos();
-
-	// restore old background
-	if (back && draw_back && LastX != -100)
-	{
-		SDL_Rect dest;
-		dest.x = LastX;
-		dest.y = LastY;
-		SDL_BlitSurface (back, NULL, sf, &dest);
-
-		SDL_UpdateRect (sf, dest.x, dest.y, dest.w, dest.h);
-	}
-
-	//change size of back surface if necessary, e.g. when the mouse cursor has changed
-	if (!back || back->h != cur->h || back->w != cur->w)
-	{
-		back = SDL_CreateRGBSurface (Video.getSurfaceType(), cur->w, cur->h, 32, 0, 0, 0, 0);
-	}
-
-	// store new background
-	GetBack (sf);
-	SDL_Rect dest;
-	dest.x = DrawX;
-	dest.y = DrawY;
-	LastX = DrawX;
-	LastY = DrawY;
-
-	//draw mouse
-	SDL_BlitSurface (cur, NULL, sf, &dest);
-	SDL_UpdateRect (sf, dest.x, dest.y, dest.w, dest.h);
+	if (sdlCursor) SDL_FreeCursor (sdlCursor);
 }
 
 bool cMouse::SetCursor (eCursor const typ)
 {
 	const SDL_Surface* const lastCur = cur;
+
 	switch (typ)
 	{
 		default:
@@ -106,56 +71,50 @@
 		case CDisable:   cur = GraphicsData.gfx_Cdisable;    break;
 		case CActivate:  cur = GraphicsData.gfx_Cactivate;   break;
 	}
-	return lastCur != cur;
+	if (lastCur == cur)
+	{
+		return false;
+	}
+	if (sdlCursor) SDL_FreeCursor (sdlCursor);
+	int hotx = 0;
+	int hoty = 0;
+	getCursorOffset (hotx, hoty);
+	sdlCursor = SDL_CreateColorCursor (cur, hotx, hoty);
+	SDL_SetCursor (sdlCursor);
+	return true;
 }
 
-// Liest den Hintergrund in das Back-Surface ein:
-void cMouse::GetBack (SDL_Surface* sf)
-{
-	SDL_Rect scr;
-	GetPos();
-	scr.x = DrawX;
-	scr.y = DrawY;
-	scr.w = back->w;
-	scr.h = back->h;
-	SDL_BlitSurface (sf, &scr, back, NULL);
-}
-
-void cMouse::restoreBack (SDL_Surface* sf)
-{
-	SDL_Rect dest;
-	dest.x = LastX;
-	dest.y = LastY;
-	SDL_BlitSurface (back, NULL, sf, &dest);
-}
-
 //updates the internal mouse position
-void cMouse::GetPos()
+void cMouse::updatePos()
 {
 	SDL_GetMouseState (&x, &y);
-
-	// Cursor Offset bestimmen:
-	int offX;
-	int offY;
-
-	getCursorOffset (offX, offY);
-
-	DrawX = x + offX;
-	DrawY = y + offY;
 }
 
 // gets the cursor offset. transforms screenspace to clickspace
 void cMouse::getCursorOffset (int& x, int& y) const
 {
-	if (cur == GraphicsData.gfx_Cselect || cur == GraphicsData.gfx_Chelp || cur == GraphicsData.gfx_Cmove || cur == GraphicsData.gfx_Cmove_draft || cur == GraphicsData.gfx_Cno || cur == GraphicsData.gfx_Ctransf || cur == GraphicsData.gfx_Cband || cur == GraphicsData.gfx_Cload || cur == GraphicsData.gfx_Cmuni || cur == GraphicsData.gfx_Crepair || cur == GraphicsData.gfx_Cactivate)
+	if (cur == GraphicsData.gfx_Cselect
+		|| cur == GraphicsData.gfx_Chelp
+		|| cur == GraphicsData.gfx_Cmove
+		|| cur == GraphicsData.gfx_Cmove_draft
+		|| cur == GraphicsData.gfx_Cno
+		|| cur == GraphicsData.gfx_Ctransf
+		|| cur == GraphicsData.gfx_Cband
+		|| cur == GraphicsData.gfx_Cload
+		|| cur == GraphicsData.gfx_Cmuni
+		|| cur == GraphicsData.gfx_Crepair
+		|| cur == GraphicsData.gfx_Cactivate)
 	{
-		x = -12;
-		y = -12;
+		x = 12;
+		y = 12;
 	}
-	else if (cur == GraphicsData.gfx_Cattack || cur == GraphicsData.gfx_Csteal || cur == GraphicsData.gfx_Cdisable || cur == GraphicsData.gfx_Cattackoor)
+	else if (cur == GraphicsData.gfx_Cattack
+			 || cur == GraphicsData.gfx_Csteal
+			 || cur == GraphicsData.gfx_Cdisable
+			 || cur == GraphicsData.gfx_Cattackoor)
 	{
-		x = -19;
-		y = -16;
+		x = 19;
+		y = 16;
 	}
 	else
 	{
@@ -175,6 +134,16 @@
 	return moved;
 }
 
+void cMouse::Show()
+{
+	SDL_ShowCursor (true);
+}
+
+void cMouse::Hide()
+{
+	SDL_ShowCursor (false);
+}
+
 // Liefert die Koordinaten der Kachel unter der Maus:
 int cMouse::getKachelX (const cGameGUI& gameGUI) const
 {
Index: mouse.h
===================================================================
--- mouse.h	(revision 3442)
+++ mouse.h	(working copy)
@@ -19,12 +19,13 @@
 #ifndef mouseH
 #define mouseH
 
-#include "autosurface.h"
 #include "defines.h"
-#include <SDL.h>
 
 class cGameGUI;
+struct SDL_Surface;
+struct SDL_Cursor;
 
+
 // Die Mauszeigertypen ///////////////////////////////////////////////////////
 enum eCursor {CHand, CNo, CSelect, CMove, CPfeil1, CPfeil2, CPfeil3, CPfeil4, CPfeil6, CPfeil7, CPfeil8, CPfeil9, CHelp, CAttack, CBand, CTransf, CLoad, CMuni, CRepair, CSteal, CDisable, CActivate, CMoveDraft, CAttackOOR};
 
@@ -33,22 +34,16 @@
 {
 public:
 	cMouse();
+	~cMouse();
 
-	void draw (bool draw_back, SDL_Surface* sf);
-
 	// Set a new cursor.
 	bool SetCursor (eCursor);
 
-	void GetBack (SDL_Surface* sf);
-	/**
-	* Draws the currently stored background to sf
-	*/
-	void restoreBack (SDL_Surface* sf);
-	void GetPos();
+	void updatePos();
 	void getCursorOffset (int& x, int& y) const;
 	bool moved();
-	void Show() {LastX = -100; visible = true;}
-	void Hide() {visible = false;}
+	void Show();
+	void Hide();
 	/**
 	* return the X Coordinate of the Cursor on the map
 	*/
@@ -57,19 +52,14 @@
 	* return the Y Coordinate of the Cursor on the map
 	*/
 	int getKachelY (const cGameGUI& gameGUI) const;
-private:
-	bool visible; // Gibt an, ob die Maus angezeigt werden soll.
+
 public:
 	SDL_Surface* cur; // Current Cursor.
 private:
-	AutoSurface back; // Zum Speichern des Maushintergrundes.
+	SDL_Cursor* sdlCursor;
 public:
 	int x, y; /** the pixel position of the cursor on the map */
 	bool isDoubleClick;
-private:
-	int prevScreenX, prevScreenY;
-	int LastX, LastY; // Die letzte Position der Maus.
-	int DrawX, DrawY; // Die Position, an die die Maus gezeichnet werden soll.
 };
 
 // Die Maus //////////////////////////////////////////////////////////////////
